/******************************************************************************
 * bupman.hpp
 * Secondary wrapper around BupBoop to automatically manage resources.
 *-----------------------------------------------------------------------------
 * Copyright (C) 2015 - 2016 Osman Celimli
 * For conditions of distribution and use, see copyright notice in playtone.cpp
 ******************************************************************************/
#ifndef BUPMAN
#define BUPMAN

class BupMan {
	public:
		BupMan(HWND hParent);
		~BupMan(void);

		/**
		 * ---- WRAPPED BUPBOOP CALLS ----
		 */
		void pause(void);
		void resume(void);
		INT isPaused(void);
		void stopAll(void);

		void playMusic(void);
		void stopMusic(void);
		void attenMusic(BYTE cVol);
		INT checkMusic(void);
		INT getMood(void);

		void playSFX(INT iPriority, INT iVol_Left, INT iVol_Right);
		void stopSFX(void);

		/**
		 * ---- DRIVER CONTROL ----
		 */
		HRESULT startDriver(void);
		HRESULT stopDriver(void);

		HRESULT startLog(LPSTR pszFile);
		HRESULT stopLog(void);

		HRESULT loadFile(LPSTR pszFile, BYTE **ppDest);
		HRESULT loadSamples(LPSTR pszFile);
		HRESULT loadMacros(LPSTR pszFile);
		HRESULT loadMusic(LPSTR pszFile);
		HRESULT loadSFX(LPSTR pszFile);

		/**
		 * ---- PEEKABLE STATUSES ----
		 */
		BOOL mbRunning,mbLogging;

		BOOL mbGotSamples,mbGotMacros;
		BOOL mbGotMusic;
		BOOL mbGotSFX;

	private:
		HWND mhParent;

		BYTE *mpSamples,*mpMacros;
		BYTE *mpMusic,*mpSFX;
		INT miPriSFX;
};

#endif
